/* call_gol.c the calling function for John Conway's Game of Life

 * Copyright (C) 2003 -- Lesley Shannon -- University of Toronto

 * This software is available to the user without any license fee or
 * royalty on an "as is" basis with no guarantee of support.   The author 
 * and University of Toronto disclaim any and all warranties, whether 
 * express, implied or statuary, including any implied warranties or
 * merchantability or of fitness for a particular pupose.
 *
 * Only not-for-profit use of this software is permitted.  The user may
 * modify or use the source code for other not-for-profit research
 * endeavours, provided that all copyright attribution on the source code is
 * retained, and the original or modified source code is not redistributed,
 * in whole or in part, or included in or with any commerical product, except
 * by written agreement with the authors, and full and complete attribution
 * for use of the code is given in any resulting publications.
 */

/* Author: Lesley Shannon
 * Date:   July 31, 2002
 * File:   call_gol.c
 *
 * Description:
 *
 * Processes user inputs and outputs for the game of life.  
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <stdio.h>
#include <math.h>
#include "g_o_l.h"


int main (int argc, char *argv[])
{
        int i, j, lop_cnt;        /* Used as loop counters.*/
        int flag;
        char character;
        int generation;
	/*char OutFileName[20] = "gol_out.txt";*/

        if (argc != 3)
        {
                printf("Usage: %s [input filename] [output filename].\n", 
				argv[0]);
                return 1;
        }

        InFileName = argv[1];
        InFile = fopen(InFileName, "r");

        if (InFile==NULL)
        {
                printf("Error. Unable to open file %s.\n", InFileName);
                return 1;
        }
        else
        {
                printf("\nSuccessfully opened file %s.\n", InFileName);
        }

        OutFileName = argv[2];
        OutFile = fopen(OutFileName, "w");

        if (OutFile==NULL)
        {
                printf("Error. Unable to open file %s.\n", OutFileName);
                return 1;
        }
        else
        {
                printf("Successfully opened file %s.\n\n", OutFileName);
        }

        /* Set all the grid fields to zero- as a "known" starting point.*/
        init_grid();

        /* Initialize the grid with a "seed" pattern. */
        seed_the_grid();
        generation = 0;

	display_present_generation(generation);


        for (lop_cnt=NUM_PASSES; lop_cnt>0; lop_cnt--)
        {
                /*Calculate the "next" state for each cell in the grid.*/
                set_grid_next_state();

                /* Make the next generation the present generation*/
                set_new_grid_pres_state();
		/*display_present_generation(generation);*/

                generation++; /*It's the next generation.*/

        }

	display_present_generation(generation);
	write_outfile();

        return 0;

}

